{% extends 'main_app/base.html' %}

{% load static %}

{% block specific_css %}
    <link href="https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.6/css/select2.min.css" rel="stylesheet"/>
    <link rel="stylesheet" type="text/css" href="https://cdn.datatables.net/1.10.19/css/jquery.dataTables.css">
    <link rel="stylesheet" type="text/css" href="{% static "courses/css/landing_page.css" %}">
    <style>
        .dataTables_filter {
            display: none;
        }
    </style>
{% endblock specific_css %}

{% block content %}
    <div class="container">
        <div class="row my-5 justify-content-center">
            <h3>Search Courses</h3>
        </div>
        <div class="row my-5">
            <div class="col">
                <span>Code &nbsp;</span>
                <span>
                    <select id="select-code" class="filter" autocomplete="off" multiple style="width: 400px;">
                        {% for code in codes %}
                            <option value="{{ code }}">{{ code }}</option>
                        {% endfor %}
                    </select>
                </span>
            </div>
            <div class="col">
                <span>Name &nbsp;</span>
                <span>
                    <select id="select-name" class="filter" autocomplete="off" multiple style="width: 400px;">
                        {% for name in names %}
                            <option value="{{ name }}">{{ name }}</option>
                        {% endfor %}
                    </select>
                </span>
            </div>
        </div>
        <div class="row">
            <div class="col">
                <table id="courses_table" class="table table-hover">
                    <thead>
                    <tr>
                        <th>Code</th>
                        <th>Name</th>
                    </tr>
                    </thead>
                    <tbody>
                    </tbody>
                </table>
            </div>
        </div>
    </div>
{% endblock content %}


{% block specific_js %}
    <script src="https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.6/js/select2.min.js"></script>
    <script type="text/javascript" charset="utf8"
            src="https://cdn.datatables.net/1.10.19/js/jquery.dataTables.js"></script>

    <!-- Javascript here because otherwise the Django tags will not work -->
    <script type="text/javascript">
        $(document).ready(function () {
            $(".filter").select2();

            let table = $('#courses_table');

            // function to load the datatable
            const load = (params) => {
                // first we clone the params
                let clean_params = {"code": [], "name": []};
                clean_params.code = [... params.code];
                clean_params.name = [... params.name];

                // if params was empty we want to simply show everything
                if (params.code.length === 0 && params.name.length === 0) {
                    {% for code in codes %}
                        clean_params.code.push('{{ code }}');
                    {% endfor %}
                    {% for name in names %}
                        clean_params.name.push('{{ name }}');
                    {% endfor %}
                }

                // if the datatable was created before we destroy it
                table.DataTable().destroy();

                // generate datatable
                table.DataTable({
                    "processing": true,
                    "ajax": {
                        "processing": true,
                        "url": "{% url 'courses_as_json' %}",
                        "method": 'GET',
                        "data": clean_params,
                        "dataSrc": ""
                    },
                    "columns": [
                        {"data": null, render: function (data, type, full, meta) {
                                return '<a href="/course/' + full["pk"] + '">' + full["fields"]["code"] + '</a>';
                            }
                        },
                        {"data": null, render: function (data, type, full, meta) {
                                return '<a href="/course/' + full["pk"] + '">' + full["fields"]["name"] + '</a>';
                            }
                        }
                    ]
                });
            };

            // initially the search terms are empty
            let searchTerms = {"code": [], "name": []};

            // load datatable
            load(searchTerms);

            let select_code = $('#select-code');

            // add to search terms
            select_code.on('select2:select', function (e) {
                let data = e.params.data;
                searchTerms.code.push(data['text']);
                load(searchTerms);
            });

            // remove from search terms
            select_code.on('select2:unselect', function (e) {
                let data = e.params.data;
                for (let i = 0; i < searchTerms.code.length; i++) {
                    if (searchTerms.code[i] === data['text']) {
                        searchTerms.code.splice(i, 1);
                        i--;
                    }
                }
                load(searchTerms);
            });

            let select_name = $('#select-name');

            // add to search terms
            select_name.on('select2:select', function (e) {
                let data = e.params.data;
                searchTerms.name.push(data['text']);
                load(searchTerms);
            });

            // remove from search terms
            select_name.on('select2:unselect', function (e) {
                let data = e.params.data;
                for (let i = 0; i < searchTerms.name.length; i++) {
                    if (searchTerms.name[i] === data['text']) {
                        searchTerms.name.splice(i, 1);
                        i--;
                    }
                }
                load(searchTerms);
            });
        });
    </script>

    <script>
    $("#search_courses_light").css("font-weight", "Bold");
    </script>

{% endblock specific_js %}